Package org.optaplanner.core.impl.score.stream.bavet.bi

## Class BavetScoringBiNode<A,​B>

- java.lang.Object
- - org.optaplanner.core.impl.score.stream.bavet.common.BavetAbstractNode
  - - org.optaplanner.core.impl.score.stream.bavet.bi.BavetAbstractBiNode<A,​B>
    - - org.optaplanner.core.impl.score.stream.bavet.bi.BavetScoringBiNode<A,​B>

- All Implemented Interfaces:
    `BavetNode`, `BavetScoringNode`

      public final class BavetScoringBiNode<A,​B>
      extends BavetAbstractBiNode<A,​B>
      implements BavetScoringNode

- - ### Field Summary

    - ### Fields inherited from class org.optaplanner.core.impl.score.stream.bavet.common.BavetAbstractNode

      `nodeIndex, session`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `BavetScoringBiNode​(BavetConstraintSession session, int nodeIndex, String constraintPackage, String constraintName, Score<?> constraintWeight, TriFunction<A,​B,​Consumer<Score<?>>,​UndoScoreImpacter> scoreImpacter)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `<Score_ extends Score<Score_>> ConstraintMatchTotal<Score_>` | `buildConstraintMatchTotal​(Score_ zeroScore)` |
    `BavetScoringBiTuple<A,​B>` | `createTuple​(BavetAbstractBiTuple<A,​B> parentTuple)` |
    `String` | `getConstraintId()` |
    `String` | `getConstraintName()` |
    `String` | `getConstraintPackage()` |
    `Score<?>` | `getConstraintWeight()` |
    `void` | `refresh​(BavetAbstractTuple uncastTuple)` |
    `String` | `toString()` |

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.bavet.bi.BavetAbstractBiNode

      `addChildNode, getChildNodeList`

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.bavet.common.BavetAbstractNode

      `getNodeIndex`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.impl.score.stream.bavet.common.BavetNode

      `getNodeIndex`

- - ### Constructor Detail

    - #### BavetScoringBiNode

          public BavetScoringBiNode​(BavetConstraintSession session,
                                    int nodeIndex,
                                    String constraintPackage,
                                    String constraintName,
                                    Score<?> constraintWeight,
                                    TriFunction<A,​B,​Consumer<Score<?>>,​UndoScoreImpacter> scoreImpacter)

  - ### Method Detail

    - #### createTuple

          public BavetScoringBiTuple<A,​B> createTuple​(BavetAbstractBiTuple<A,​B> parentTuple)

      Specified by:
        `createTuple` in class `BavetAbstractBiNode<A,​B>`

    - #### refresh

          public void refresh​(BavetAbstractTuple uncastTuple)

      Specified by:
        `refresh` in class `BavetAbstractNode`

    - #### buildConstraintMatchTotal

          public <Score_ extends Score<Score_>> ConstraintMatchTotal<Score_> buildConstraintMatchTotal​(Score_ zeroScore)

      Specified by:
        `buildConstraintMatchTotal` in interface `BavetScoringNode`
      Type Parameters:
        `Score_` - the `Score` type
      Parameters:
        `zeroScore` - never null
      Returns:
        never null

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### getConstraintPackage

          public String getConstraintPackage()

      Specified by:
        `getConstraintPackage` in interface `BavetScoringNode`
      Returns:
        never null

    - #### getConstraintName

          public String getConstraintName()

      Specified by:
        `getConstraintName` in interface `BavetScoringNode`
      Returns:
        never null

    - #### getConstraintId

          public String getConstraintId()

      Specified by:
        `getConstraintId` in interface `BavetScoringNode`
      Returns:
        never null

    - #### getConstraintWeight

          public Score<?> getConstraintWeight()

      Specified by:
        `getConstraintWeight` in interface `BavetScoringNode`
      Returns:
        never null